package rigger

import (
	"ciyon/web/admin"
	c "ciyon/zciyon"
	"fmt"
	"net/http"
)

func debug_user_setwhere(post *c.CiyPost) (map[string]any, *c.CiySQL) {
	query := post.Getobj("query")
	csql := c.NewCiySQL("zc_debug_user")
	csql.Where("name like", c.Getstr(query, "name"))
	csql.Where("user like", c.Getstr(query, "user"))
	csql.Where("targettype", c.Getstr(query, "targettype"))
	csql.Where("isuse", c.Getstr(query, "isuse"))
	order := c.Getstr(query, "order", "id desc")
	csql.Order(order)
	query["order"] = order
	return query, csql
}
func Debug_user_init(w http.ResponseWriter, r *http.Request) bool {
	post := c.NewCiyPost(w, r)
	_, userid := admin.Verifyfast(r, c.CiyDB, post)
	if userid == 0 {
		return false
	}
	where, csql := debug_user_setwhere(post)
	pageno := post.Getint("pageno", 1)
	pagecount := post.Getint("pagecount", 10)
	csql.Limit(pageno, pagecount)
	rows, mainrowcount, err := c.CiyDB.Get(csql, post.Getint("count"))
	if err != nil {
		return c.ErrJSON(w, "读取错误", err)
	}
	ret := map[string]any{}
	ret["where"] = where
	ret["pageno"] = pageno
	ret["pagecount"] = pagecount
	ret["count"] = mainrowcount
	ret["list"] = rows
	if post.Getbool("field") {
		field, fshow := c.CiyDB.GetField(csql)
		c.FieldAdd(&field, &fshow, 0, "_btn", "操作")
		ret["fshow"] = fshow
		ret["field"] = field
	}
	if post.Getbool("once") {
		once := map[string]any{}
		input := make([]map[string]any, 0)
		isusevals := c.CiyDB.Getdbcodes("zc_debug_user", "isuse")
		input = append(input, map[string]any{
			"form":   "targettype",
			"type":   "select",
			"name":   "子系统",
			"select": "targettype",
			"all":    "全部",
		})
		input = append(input, map[string]any{
			"form":   "isuse",
			"type":   "select",
			"name":   "开关",
			"select": isusevals,
			"all":    "全部",
		})
		// input = append(input, map[string]any{
		// 	"form":  "isuse",
		// 	"type":  "switch",
		// 	"name":  "开关",
		// 	"value": isusevals,
		// })
		input = append(input, map[string]any{
			"form": "name",
			"type": "input",
			"name": "显示名",
			"prop": ` style="width:8em;"`,
		})
		input = append(input, map[string]any{
			"form": "user",
			"type": "input",
			"name": "用户名",
			"prop": ` style="width:8em;"`,
		})
		once["input"] = input
		ret["once"] = once
	}
	return c.SuccJSON(w, r, ret)
}
func Debug_user_update(w http.ResponseWriter, r *http.Request) bool {
	post := c.NewCiyPost(w, r)
	_, userid := admin.Verifyfast(r, c.CiyDB, post)
	if userid == 0 {
		return false
	}
	if admin.Nopower(c.CiyDB, userid, "p991u") {
		return c.ErrJSON(w, "您未被授权操作")
	}
	id := post.Getint("id")
	targettype := post.Getint("targettype")
	if targettype <= 0 {
		return c.ErrJSON(w, "请选择子系统")
	}
	isuse := post.Getint("isuse")
	name := post.Get("name")
	if name == "" {
		return c.ErrJSON(w, "请填写显示名")
	}
	user := post.Get("user")
	if user == "" {
		return c.ErrJSON(w, "请填写用户名")
	}
	pass := post.Get("pass")
	if pass == "" {
		return c.ErrJSON(w, "请填写密码")
	}
	var err error
	var datarow map[string]any
	if id > 0 {
		csql := c.NewCiySQL("zc_debug_user")
		csql.Where("id", id)
		datarow, err = c.CiyDB.Getone(csql)
		if datarow == nil {
			return c.ErrJSON(w, "数据不存在", err)
		}
	}
	updata := map[string]any{}
	err = c.CiyDB.Tran(func() error {
		var csql *c.CiySQL
		csql = c.NewCiySQL("zc_debug_user")
		csql.Where("targettype", targettype)
		csql.Where("user", user)
		csql.Column("id")
		chkid := c.Toint(c.CiyDB.Get1(csql))
		if chkid > 0 && ((id > 0 && chkid != id) || id == 0) {
			return fmt.Errorf("数据已存在")
		}
		updata["targettype"] = targettype
		updata["isuse"] = isuse
		updata["name"] = name
		updata["user"] = user
		updata["pass"] = pass
		csql = c.NewCiySQL("zc_debug_user")
		if id > 0 {
			csql.Where("id", id)
			_, err = c.CiyDB.Update(csql, updata)
		} else {
			id, err = c.CiyDB.Insert(csql, updata)
		}
		updata["id"] = id
		if err != nil {
			return fmt.Errorf("更新失败:%v", err)
		}
		admin.SaveLogDB(c.CiyDB, "zc_debug_user", datarow, updata)
		return nil
	})
	if err != nil {
		return c.ErrJSON(w, "事务"+err.Error())
	}
	ret := map[string]any{}
	ret["data"] = updata
	return c.SuccJSON(w, r, ret)
}

func Debug_user_del(w http.ResponseWriter, r *http.Request) bool {
	post := c.NewCiyPost(w, r)
	_, userid := admin.Verifyfast(r, c.CiyDB, post)
	if userid == 0 {
		return false
	}
	if admin.Nopower(c.CiyDB, userid, "p991u") {
		return c.ErrJSON(w, "您未被授权操作")
	}
	ids := post.Get("ids")
	if ids == "" {
		return c.ErrJSON(w, "请选择至少一条")
	}
	csql := c.NewCiySQL("zc_debug_user")
	csql.Where("id in", ids)
	rows, _, err := c.CiyDB.Get(csql)
	if err != nil {
		return c.ErrJSON(w, "读取数据错误", err)
	}
	vids := make([]int, 0)
	err = c.CiyDB.Tran(func() error {
		for _, row := range rows {
			delid := c.Toint(row["id"])
			c.Delme(c.CiyDB, delid, "zc_debug_user")
			admin.SaveLogDB(c.CiyDB, "zc_debug_user", row, nil)
			vids = append(vids, delid)
		}
		return nil
	})
	if err != nil {
		return c.ErrJSON(w, "事务"+err.Error())
	}
	ret := map[string]any{}
	ret["ids"] = vids
	return c.SuccJSON(w, r, ret)
}

func Debug_user_getlocal(w http.ResponseWriter, r *http.Request) bool {
	post := c.NewCiyPost(w, r)
	_, userid := admin.Verifyfast(r, c.CiyDB, post)
	if userid == 0 {
		return false
	}
	if admin.Nopower(c.CiyDB, userid, "p991n") {
		return c.ErrJSON(w, "您未被授权操作")
	}
	targettype := post.Getint("targettype")
	if targettype == 0 {
		return c.ErrJSON(w, "请选择子系统")
	}
	csql := c.NewCiySQL("zc_debug_user")
	csql.Where("targettype", targettype)
	csql.Where("isuse", 1)
	csql.Column("id,name,user,pass")
	rows, _, err := c.CiyDB.Get(csql)
	if err != nil {
		return c.ErrJSON(w, "读取错误", err)
	}
	ret := map[string]any{}
	ret["list"] = rows
	return c.SuccJSON(w, r, ret)
}
